
/****** Object:  StoredProcedure [dbo].[SP_INVOICE_CREATION_VERIFICATION]    Script Date: 30/04/2021 17:02:34 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

-- =============================================
-- Author:		FID.Ridwan
-- Create date: 2020-12-11
-- Description:	
-- 
-- =============================================
ALTER PROCEDURE [dbo].[SP_INVOICE_CREATION_VERIFICATION] @USER_ID VARCHAR(20) = 'agan'
	,@RI_V_PROCESSID BIGINT
	,@RI_V_SUPP_CD VARCHAR(10)
	,@RI_V_REGION VARCHAR(30)
	,@RESULT VARCHAR(1) OUTPUT
AS
BEGIN
	SET NOCOUNT ON;

	DECLARE @IsError CHAR(1) = 'N'
	DECLARE @FUNCTION_ID AS VARCHAR(MAX) = '51002'
		,@MODULE_ID AS VARCHAR(MAX) = '5'
		,@FUNTION_NM AS VARCHAR(MAX) = 'SP Invoice Creation Verification'
		,@MSG_TXT AS VARCHAR(MAX)
		,@MSG_TYPE AS VARCHAR(MAX)
		,@LOG_LOCATION AS VARCHAR(MAX) = 'SP_INVOICE_CREATION_VERIFICATION'
		,@L_ERR AS INT = 0
		,@N_ERR AS INT = 0
		,@PARAM1 AS VARCHAR(MAX)
		,@PARAM2 AS VARCHAR(MAX)
		,@PARAM3 AS VARCHAR(MAX)
		,@query VARCHAR(MAX)
		,@ICSSrvrName NVARCHAR(256)
		,@ICSDBName NVARCHAR(256)
		,@L_V_STATUS_SUPP VARCHAR(10) = 'N'

	BEGIN TRY
		-- check invoice verification status on file GR/IR
		UPDATE T
		SET T.REMARKS = 'Incorrect (Data must be invoiced based on PO)'
			,T.IS_PROCESS = 1
			,T.VALIDATION_TYPE = 'E'
			,T.LOC = 'Check Remark'
		FROM #TEMP_INV_UPLOAD_VALIDASI T
		JOIN #TEMP_R_GRIR_BY_MAT_NO_ICS R ON R.INV_REF_NO = T.SUPP_MANIFEST
			AND R.ICS_MAT_NO = T.MAT_NO
			AND R.PART_COLOR_SFX = T.PART_COLOR_SFX
			AND R.PACKING_TYPE = T.PACKING_TYPE
			AND R.COMP_PRICE_CD = T.COMP_PRICE_CD
			AND ISNULL(R.CANCEL_FLAG, '0') = '0' --'N'
			AND COALESCE(INV_WO_GR_FLAG, 'N') = 'Y'
		WHERE 1 = 1
			AND T.REGION = @RI_V_REGION
			AND T.IS_PROCESS = 0;

		UPDATE T
		SET T.REMARKS = 'Incorrect (Data not found in GR IR with Manifest No = [' + ISNULL(T.SUPP_MANIFEST, '') + '])'
			,T.IS_PROCESS = 1
			,T.VALIDATION_TYPE = 'E'
			,T.LOC = 'Check Remark'
		FROM #TEMP_INV_UPLOAD_VALIDASI T
		LEFT JOIN #TEMP_R_GRIR_BY_MAT_NO_ICS R ON R.MAT_DOC_NO = T.MAT_DOC_NO
			AND R.ITEM_NO = T.MAT_DOC_ITEM
			AND R.COMP_PRICE_CD = T.COMP_PRICE_CD
			AND R.INV_REF_NO = T.SUPP_MANIFEST
			AND ISNULL(R.CANCEL_FLAG, '0') = '0' --'N'
			AND COALESCE(INV_WO_GR_FLAG, 'N') = 'N'
		WHERE ISNULL(R.INV_REF_NO, '') = ''
			AND T.REGION = @RI_V_REGION
			AND T.IS_PROCESS = 0;

		UPDATE T
		SET T.REMARKS = 'Incorrect (Data already invoiced by [' + R.INV_NO + '])'
			,T.IS_PROCESS = 1
			,T.VALIDATION_TYPE = 'E'
			,T.LOC = 'Check Remark'
		FROM #TEMP_INV_UPLOAD_VALIDASI T
		JOIN #TEMP_R_GRIR_BY_MAT_NO_ICS R ON R.MAT_DOC_NO = T.MAT_DOC_NO
			AND R.ITEM_NO = T.MAT_DOC_ITEM
			AND R.COMP_PRICE_CD = T.COMP_PRICE_CD
			AND ISNULL(R.CANCEL_FLAG, '0') = '0' --'N'
			AND COALESCE(INV_WO_GR_FLAG, 'N') = 'N'
			AND ISNULL(R.INV_NO, '') <> ''
			AND ISNULL(R.INV_ITEM_NO, '') <> ''
		WHERE T.REGION = @RI_V_REGION
			AND T.IS_PROCESS = 0;

		-- check data invoice from vendor compare to data GR/IR document
		--A. check supplier code
		UPDATE T
		SET T.REMARKS = 'Incorrect (Supplier code is not match --> ' + T.SUPP_CD + ')'
			,T.IS_PROCESS = 1
			,T.VALIDATION_TYPE = 'E'
			,T.LOC = 'Check Remark'
		FROM #TEMP_INV_UPLOAD_VALIDASI T
		JOIN #TEMP_R_GRIR_BY_DOC_NO R ON T.MAT_DOC_NO = R.MAT_DOC_NO
			AND T.MAT_DOC_ITEM = R.ITEM_NO
			AND T.COMP_PRICE_CD = R.COMP_PRICE_CD
			AND ISNULL(CANCEL_FLAG, '0') = '0'
			AND COALESCE(INV_WO_GR_FLAG, 'N') = 'N'
			AND T.SUPP_CD <> R.SUPPLIER_CD
		WHERE T.REGION = @RI_V_REGION
			AND T.IS_PROCESS = 0

		-- B. check material number
		UPDATE T
		SET T.REMARKS = 'Incorrect (Material number is not match --> ' + R.ICS_MAT_NO + ')'
			,T.IS_PROCESS = 1
			,T.VALIDATION_TYPE = 'E'
			,T.LOC = 'Check Remark'
		FROM #TEMP_INV_UPLOAD_VALIDASI T
		JOIN #TEMP_R_GRIR_BY_DOC_NO R ON T.MAT_DOC_NO = R.MAT_DOC_NO
			AND T.MAT_DOC_ITEM = R.ITEM_NO
			AND T.COMP_PRICE_CD = R.COMP_PRICE_CD
			AND ISNULL(CANCEL_FLAG, '0') = '0'
			AND COALESCE(INV_WO_GR_FLAG, 'N') = 'N'
			AND T.MAT_NO <> R.ICS_MAT_NO
		WHERE T.REGION = @RI_V_REGION
			AND T.IS_PROCESS = 0

		-- C. check quantity and price
		IF EXISTS (
				SELECT TOP 1 1
				FROM #TEMP_INV_UPLOAD_VALIDASI T
				JOIN #TEMP_R_GRIR_BY_DOC_NO R ON T.MAT_DOC_NO = R.MAT_DOC_NO
					AND T.MAT_DOC_ITEM = R.ITEM_NO
					AND T.COMP_PRICE_CD = R.COMP_PRICE_CD
					AND ISNULL(CANCEL_FLAG, '0') = '0'
					AND COALESCE(INV_WO_GR_FLAG, 'N') = 'N'
					AND (
						(ISNULL(R.MOVEMENT_QTY, 0) <> ISNULL(T.S_QUANTITY, 0))
						OR ((ISNULL(R.PO_DETAIL_PRICE, 0) * ISNULL(R.MOVEMENT_QTY, 0)) <> ISNULL(T.AMMOUNT, 0))
						OR (ISNULL(R.PO_DETAIL_PRICE, 0) <> ISNULL(T.PRICE_AMT, 0))
						)
				WHERE T.REGION = @RI_V_REGION
					AND T.IS_PROCESS = 0
				)
		BEGIN
			UPDATE A
			SET A.REMARKS = B.REMARKS
				,A.IS_PROCESS = 1
				,A.VALIDATION_TYPE = 'E'
				,A.LOC = 'Check Remark'
			FROM #TEMP_INV_UPLOAD_VALIDASI A
			JOIN (
				SELECT CASE 
						WHEN (ISNULL(R.MOVEMENT_QTY, 0) <> ISNULL(T.S_QUANTITY, 0))
							AND (ISNULL(R.PO_DETAIL_PRICE, 0) <> ISNULL(T.PRICE_AMT, 0))
							AND ((ISNULL(R.PO_DETAIL_PRICE, 0) * ISNULL(R.MOVEMENT_QTY, 0)) <> ISNULL(T.AMMOUNT, 0))
							THEN 'Incorrect(Quantity is not match --> ' + CONVERT(VARCHAR, ISNULL(R.MOVEMENT_QTY, 0)) + ') and Incorrect(Price is not match --> ' + CONVERT(VARCHAR, ISNULL(R.PO_DETAIL_PRICE, 0)) + ') Incorrect(Amount is not match --> ' + CONVERT(VARCHAR, ISNULL(T.AMMOUNT, 0)) + ')'
						WHEN (ISNULL(R.MOVEMENT_QTY, 0) <> ISNULL(T.S_QUANTITY, 0))
							AND (ISNULL(R.PO_DETAIL_PRICE, 0) <> ISNULL(T.PRICE_AMT, 0))
							THEN 'Incorrect(Quantity is not match --> ' + CONVERT(VARCHAR, ISNULL(R.MOVEMENT_QTY, 0)) + ') and Incorrect(Price is not match --> ' + CONVERT(VARCHAR, ISNULL(R.PO_DETAIL_PRICE, 0)) + ')'
						WHEN (ISNULL(R.MOVEMENT_QTY, 0) <> ISNULL(T.S_QUANTITY, 0))
							AND ((ISNULL(R.PO_DETAIL_PRICE, 0) * ISNULL(R.MOVEMENT_QTY, 0)) <> ISNULL(T.AMMOUNT, 0))
							THEN 'Incorrect(Quantity is not match --> ' + CONVERT(VARCHAR, ISNULL(R.MOVEMENT_QTY, 0)) + ') and Incorrect(Amount is not match --> ' + CONVERT(VARCHAR, ISNULL(R.PO_DETAIL_PRICE, 0) * ISNULL(R.MOVEMENT_QTY, 0)) + ')'
						WHEN (ISNULL(R.PO_DETAIL_PRICE, 0) <> ISNULL(T.PRICE_AMT, 0))
							AND ((ISNULL(R.PO_DETAIL_PRICE, 0) * ISNULL(R.MOVEMENT_QTY, 0)) <> ISNULL(T.AMMOUNT, 0))
							THEN 'Incorrect(Price is not match --> ' + CONVERT(VARCHAR, ISNULL(R.PO_DETAIL_PRICE, 0)) + ')Incorrect(Amount is not match --> ' + CONVERT(VARCHAR, ISNULL(R.PO_DETAIL_PRICE, 0) * ISNULL(R.MOVEMENT_QTY, 0)) + ')'
						WHEN (ISNULL(R.MOVEMENT_QTY, 0) <> ISNULL(T.S_QUANTITY, 0))
							AND (ISNULL(R.PO_DETAIL_PRICE, 0) <> ISNULL(T.PRICE_AMT, 0))
							THEN 'Incorrect(Quantity is not match --> ' + CONVERT(VARCHAR, ISNULL(R.MOVEMENT_QTY, 0)) + ') and Incorrect(Price is not match --> ' + CONVERT(VARCHAR, ISNULL(R.PO_DETAIL_PRICE, 0)) + ')'
						WHEN ISNULL(R.MOVEMENT_QTY, 0) <> ISNULL(T.S_QUANTITY, 0)
							THEN 'Incorrect(Quantity is not match --> ' + CONVERT(VARCHAR, ISNULL(R.MOVEMENT_QTY, 0)) + ')'
						WHEN ISNULL(R.PO_DETAIL_PRICE, 0) <> ISNULL(T.PRICE_AMT, 0)
							THEN 'Incorrect(Price is not match --> ' + CONVERT(VARCHAR, ISNULL(R.PO_DETAIL_PRICE, 0)) + ')'
						WHEN (ISNULL(R.PO_DETAIL_PRICE, 0) * ISNULL(R.MOVEMENT_QTY, 0)) <> ISNULL(T.AMMOUNT, 0)
							THEN 'Incorrect(Amount is not match --> ' + CONVERT(VARCHAR, ISNULL(R.PO_DETAIL_PRICE, 0) * ISNULL(R.MOVEMENT_QTY, 0)) + ')'
						END REMARKS
					,T.MAT_DOC_NO
					,T.MAT_DOC_ITEM
					,T.COMP_PRICE_CD
					,T.ROW_NO
				FROM #TEMP_INV_UPLOAD_VALIDASI T
				JOIN #TEMP_R_GRIR_BY_DOC_NO R ON T.MAT_DOC_NO = R.MAT_DOC_NO
					AND T.MAT_DOC_ITEM = R.ITEM_NO
					AND T.COMP_PRICE_CD = R.COMP_PRICE_CD
					AND ISNULL(CANCEL_FLAG, '0') = '0'
					AND COALESCE(INV_WO_GR_FLAG, 'N') = 'N'
					AND (
						(ISNULL(R.MOVEMENT_QTY, 0) <> ISNULL(T.S_QUANTITY, 0))
						OR ((ISNULL(R.PO_DETAIL_PRICE, 0) * ISNULL(R.MOVEMENT_QTY, 0)) <> ISNULL(T.AMMOUNT, 0))
						OR (ISNULL(R.PO_DETAIL_PRICE, 0) <> ISNULL(T.PRICE_AMT, 0))
						)
				WHERE T.REGION = @RI_V_REGION
					AND T.IS_PROCESS = 0
				) B ON A.MAT_DOC_NO = B.MAT_DOC_NO
				AND A.MAT_DOC_ITEM = B.MAT_DOC_ITEM
				AND A.COMP_PRICE_CD = B.COMP_PRICE_CD
				AND A.IS_PROCESS = 0
				AND A.REGION = @RI_V_REGION
		END

		/* ----- 5. check invoice data ----- */
		UPDATE T
		SET T.REMARKS = 'Incorrect (Reference document has been invoiced)'
			,T.IS_PROCESS = 1
			,T.VALIDATION_TYPE = 'E'
			,T.LOC = 'Check Remark'
		FROM #TEMP_INV_UPLOAD_VALIDASI T
		JOIN TB_R_INV_D B WITH (NOLOCK) ON B.MAT_DOC_NO = T.MAT_DOC_NO
			AND B.MAT_DOC_ITEM = T.MAT_DOC_ITEM
			AND B.COMP_PRICE_CD = T.COMP_PRICE_CD
			AND B.INV_REF_NO = T.SUPP_MANIFEST
		JOIN TB_R_INV_H A WITH (NOLOCK) ON A.INV_NO = B.INV_NO
			AND ISNULL(A.REVERSE_FLAG, 'N') = 'N'
		WHERE 1 = 1
			AND T.IS_PROCESS = 0
			AND T.REGION = @RI_V_REGION;

		/* Exchange Rate */
		UPDATE T
		SET T.REMARKS = 'Incorrect (Currency Code does not exist on Exhange Rate master)'
			,T.IS_PROCESS = 1
			,T.VALIDATION_TYPE = 'E'
			,T.LOC = 'Exchange Rate'
		FROM #TEMP_INV_UPLOAD_VALIDASI T
		LEFT JOIN TB_M_EXCHANGE_RATE M ON M.CURRENCY_CD = ISNULL(UPPER(T.PAYMENT_CURR), '')
			AND (
				CAST(GETDATE() AS DATE) BETWEEN CAST(M.VALID_DT_FROM AS DATE)
					AND CAST(M.VALID_DT_TO AS DATE)
				)
		WHERE 1 = 1
			AND T.IS_PROCESS = 0
			AND T.REGION = @RI_V_REGION
			AND ISNULL(M.CURRENCY_CD, '') = '';

		-- calculation process
		IF EXISTS (
				SELECT TOP 1 1
				FROM #TEMP_INV_UPLOAD_VALIDASI
				WHERE VALIDATION_TYPE = 'E'
				)
		BEGIN
			SET @IsError = 'Y';

			INSERT INTO TB_R_LOG_D (
				PROCESS_ID
				,SEQUENCE_NUMBER
				,MESSAGE_ID
				,MESSAGE_TYPE
				,[MESSAGE]
				,LOCATION
				,CREATED_BY
				,CREATED_DATE
				)
			SELECT @RI_V_PROCESSID
				,ISNULL((
						SELECT MAX(SEQUENCE_NUMBER)
						FROM dbo.TB_R_LOG_D WITH (NOLOCK)
						WHERE PROCESS_ID = @RI_V_PROCESSID
						), 0) + (
					ROW_NUMBER() OVER (
						ORDER BY (
								SELECT 1
								)
						)
					)
				,'MSPT00001ERR'
				,'ERR'
				,'MSPT00001ERR : ' + W.REMARKS
				,W.LOC
				,@USER_ID
				,GETDATE()
			FROM #TEMP_INV_UPLOAD_VALIDASI W
			WHERE W.VALIDATION_TYPE = 'E'
		END

		UPDATE T
		SET T.REMARKS = 'Correct'
			,T.VALIDATION_TYPE = ''
			,T.IS_PROCESS = 1
			,T.LOC = 'OK'
			,T.N_AMMOUNT = T.PRICE_AMT * T.QUANTITY
			,T.N_AMMOUNT_CUR = (T.PRICE_AMT * T.QUANTITY) * M.EXCHANGE_RATE
			,T.V_TAX_CD = R.TAX_CD
			,T.V_COND_CATEGORY = R.CONDITION_CATEGORY
		FROM #TEMP_INV_UPLOAD_VALIDASI T
		JOIN TB_M_EXCHANGE_RATE M ON M.CURRENCY_CD = ISNULL(UPPER(T.PAYMENT_CURR), '')
			AND (
				CAST(GETDATE() AS DATE) BETWEEN CAST(M.VALID_DT_FROM AS DATE)
					AND CAST(M.VALID_DT_TO AS DATE)
				)
		JOIN #TEMP_R_GRIR_BY_DOC_NO R ON T.MAT_DOC_NO = R.MAT_DOC_NO
			AND T.MAT_DOC_ITEM = R.ITEM_NO
			AND T.COMP_PRICE_CD = R.COMP_PRICE_CD
			AND ISNULL(CANCEL_FLAG, '0') = '0'
			AND COALESCE(INV_WO_GR_FLAG, 'N') = 'N'
		WHERE 1 = 1
			AND T.IS_PROCESS = 0
			AND T.REGION = @RI_V_REGION
			
		/* summary process */
		INSERT INTO TB_S_INVOICE_UPLOAD
		(INV_DOC_ITEM, --1
			SUPP_CD, --2
			PO_NO, --3
			PO_ITEM_NO, --4
			ORI_MAT_NO, --5
			MAT_NO, --6
			PROD_PURPOSE_CD, --7
			SOURCE_TYPE, --8
			PACKING_TYPE, --9
			PART_COLOR_SFX, --10
			MAT_TEXT, --11
			MAT_DOC_NO, --12
			MAT_DOC_ITEM, --13
			COMP_PRICE_CD, --14
			SUPP_MANIFEST, --15
			DOC_DT, --16
			QUANTITY, --17
			ORDER_NO, --18
			DOCK_CD, --19
			SUPP_INV_NO, --20
			S_QUANTITY, --21
			PRICE_AMT, --22
			PAYMENT_CURR,
			CURR_CD, --23
			AMMOUNT, --24
			INV_AMT_LOCAL_CUR, --25
			TAX_CD, --26
			CONDITION_CATEGORY, --27
			VALIDATION_TYPE, --28
			REMARKS --29
			)
		SELECT (ROW_NUMBER() OVER(ORDER BY (SELECT 1))), --1   -- value from counter
			L_V_CUR_VLD.SUPP_CD, --2
			L_V_CUR_VLD.PO_NO, --3
			L_V_CUR_VLD.PO_ITEM_NO, --4
			L_V_CUR_VLD.MAT_NO, --5
			L_V_CUR_VLD.MAT_NO, --6
			L_V_CUR_VLD.PROD_PURPOSE_CD, --7
			L_V_CUR_VLD.SOURCE_TYPE_CD, --8
			L_V_CUR_VLD.PACKING_TYPE, --9
			L_V_CUR_VLD.PART_COLOR_SFX, --10
			L_V_CUR_VLD.MAT_TEXT, --11
			L_V_CUR_VLD.MAT_DOC_NO, --12
			L_V_CUR_VLD.MAT_DOC_ITEM, --13
			L_V_CUR_VLD.COMP_PRICE_CD, --14
			L_V_CUR_VLD.INV_REF_NO SUPP_MANIFEST, --15
			L_V_CUR_VLD.DOC_DT, --16
			L_V_CUR_VLD.QTY QUANTITY, --17
			L_V_CUR_VLD.ORDER_NO, --18
			L_V_CUR_VLD.DOCK_CD, --19
			L_V_CUR_VLD.SUPP_INV_NO, --20
			L_V_CUR_VLD.S_QTY S_QUANTITY, --21
			L_V_CUR_VLD.PRICE_AMT, --22
			L_V_CUR_VLD.PAY_CURR PAYMENT_CURR,
			L_V_CUR_VLD.PAY_CURR PAYMENT_CURR, --23
			T.N_AMMOUNT, --24
			T.N_AMMOUNT_CUR, --25
			T.V_TAX_CD, --26
			T.V_COND_CATEGORY, --27
			CASE WHEN T.REGION = 'REMARK' THEN L_V_CUR_VLD.VALIDATION_TYPE ELSE T.VALIDATION_TYPE END, --28 (default value)
			ISNULL(T.REMARKS, '') --29 (default value) 20-04-07
		FROM TB_T_INV_UPLOAD L_V_CUR_VLD WITH (NOLOCK)
		JOIN #TEMP_INV_UPLOAD_VALIDASI T ON L_V_CUR_VLD.PROCESS_ID = T.PROCESS_ID
			AND L_V_CUR_VLD.SUPP_CD = T.SUPP_CD
			AND L_V_CUR_VLD.ROW_NO = T.ROW_NO;

		UPDATE TR
		SET TR.REMARKS = T.REMARKS
			,TR.VALIDATION_TYPE = T.VALIDATION_TYPE
		FROM TB_T_INV_UPLOAD TR
		JOIN #TEMP_INV_UPLOAD_VALIDASI T ON TR.PROCESS_ID = T.PROCESS_ID
			AND TR.SUPP_CD = T.SUPP_CD
			AND TR.ROW_NO = T.ROW_NO;

		SET @RESULT = @IsError;
	END TRY

	BEGIN CATCH
		SET @RESULT = 'Y';
		SET @PARAM1 = CONVERT(VARCHAR(1000), ERROR_MESSAGE());

		EXEC dbo.CommonGetMessage 'MPCS00999ERR'
			,@MSG_TXT OUTPUT
			,@N_ERR OUTPUT
			,@PARAM1

		INSERT INTO TB_R_LOG_D (
			PROCESS_ID
			,SEQUENCE_NUMBER
			,MESSAGE_ID
			,MESSAGE_TYPE
			,[MESSAGE]
			,LOCATION
			,CREATED_BY
			,CREATED_DATE
			)
		SELECT @RI_V_PROCESSID
			,(
				SELECT MAX(ISNULL(SEQUENCE_NUMBER, 0)) + 1
				FROM dbo.TB_R_LOG_D WITH (NOLOCK)
				WHERE PROCESS_ID = @RI_V_PROCESSID
				)
			,'MPCS00999ERR'
			,'ERR'
			,'MPCS00999ERR : ' + @MSG_TXT
			,@LOG_LOCATION
			,@USER_ID
			,GETDATE()
	END CATCH
END
